// Created with MonoDevelop
//
//    QuickStep: Acquire, view and identify spectra 
//    Copyright (C) 2018 Thomas Klose & Torsten Schache, Hiperscan GmbH Dresden, Germany
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.


using System;
namespace Hiperscan.Extensions.ApoIdent
{
    public partial class FinderWindow : ITopLevelWindow
    {
        public void UpdateFinderStartButton()
        {
            this.Update(FinderUpdateState.DevicePollFinderButton);
        }

        public Gtk.Window GtkWindow
        {
            get { return this.finder_window; }
        }

        private volatile bool busy = false;
        public bool Busy
        {
            get
            {
                return this.busy;
            }

            private set
            {
                if (value == this.busy)
                    return;

                this.busy = value;
                this.SetBusyState();
            }
        }

        public bool SubstanceManagmentReady
        {
            get
            {
                return this.SubstanceManagement.CurrentSubstance != null &&
                    this.SubstanceManagement.CurrentClassification.IsNirMeasurable;
            }
        }

        public bool ClassifierIsFluid
        {
            get
            {
                return this.SubstanceManagement.CurrentModelClass != null &&
                           this.SubstanceManagement.CurrentModelClass.IsFluid == true;
            }
        }

        public Gtk.Button StartButton
        {
            get
            {
                return this.start_button;
            }
        }

        public void UpdateDeviceAfterExternalCalibration()
        {
            this.Update(FinderUpdateState.DeviceAfterExternalCalibration);
        }


        public void UpdateDeviceAfterInternalCalibration()
        {
            this.Update(FinderUpdateState.DeviceAfterInternalCalibration); 
        }

        public void UpdateExternalCalibrationStarted()
        {
            this.Update(FinderUpdateState.ExternalCalibration);
        }

        public void UpdateFinderInternalCalibrationStarted()
        {
            this.Update(FinderUpdateState.InternalCalibration);
        }

        public ITopLevelWindow CurrentTopLeveLWindow { get; set; }
    }
}
